function alpha = line_search(u, slope0, dir, eng0, D, epsilon, f, c1, c2, alpha_max, alpha0)

    alpha1 = 1;
    
    eng_u = eng0;
    iter = 1;
    while 1
        u_next = u + alpha1*dir;
        eng    = computeF(u_next, D, epsilon, f);
        slopec = computeFGrad(u, D, epsilon, f)'*dir;
        
        if ((eng > eng0 + slope0*c1*alpha1) || ((eng >= eng_u)&&(iter>1)))
            alpha = zoom(u, slope0, dir, alpha0, alpha1, eng0, eng_u, c1, c2, D, epsilon, f);
            return;
        end
        
        if (abs(slopec)<= -c2*slope0)
            alpha = alpha1;
            return;
        end
        
        if (slopec >=0)
            alpha = zoom(u, slope0, dir, alpha1, alpha0, eng0, eng, c1, c2, D, epsilon, f);
            return;
        end
        
        alpha0 = alpha1;
        alpha1 = min(alpha_max, alpha1*3);
        eng_u = eng;
        
        iter = iter+1;
    end
end

function alpha = zoom(u, slope0, dir, alpha_lo, alpha_hi, eng0, eng_lo, c1, c2, D, epsilon, f)
    while 1
        alpha = (alpha_lo+alpha_hi)/2;
        u_next = u + alpha * dir;
        eng = computeF(u_next, D, epsilon, f);
        
        if (eng > eng0 + slope0*c1*alpha || eng>=eng_lo)
            alpha_hi = alpha;
        else
            slopec = computeFGrad(u_next, D, epsilon, f)'*dir;
            if abs(slopec) <= -c2 * slope0
                return
            end
            if slopec * (alpha_hi - alpha_lo) >=0
                alpha_hi = alpha_lo;
                alpha_lo = alpha;
                eng_lo = eng;
            end
        end
    end
end